-- Copyright © 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.

if select(2,UnitClass("player")) ~= "MONK" then return end

local _, MonkTimers = ...

_G["MonkTimers"] = MonkTimers

local Version = 2.0

local SpellIDs = MonkTimers.SpellIDs

MonkTimers.DefaultGlobalSettings = {
	Version = 2.0,
    Profiles = {},
    Sink = {}
}

MonkTimers_Profiles = {
    ["default"] = {}
}
MonkTimers_GlobalSettings = {}

MonkTimers.DefaultProfile = {

    --General            
        Lock = false,
        FlashRed = true,
        ShowTimerBars = true,
        Tooltips = true,
        TooltipsAtButtons = true,
        TimeFont = "Friz Quadrata TT",
        TimeColor = {r=1,g=1,b=1},
        TimerBarTexture = "Blizzard",
        TimerBarColor = {r=0.5,g=0.5,b=1.0,a=1.0},
        ShowKeybinds = true,
        HideInVehicle = true,
        StopPulse = true,
        TimersOnButtons = false,
        
        Timers = true,
        TimerSize = 30,
        TimerTimeHeight = 12,
        TimerOOCAlpha = 0.4,
        TimersOnButtons = true,
        Clickthrough = false,
        HideTimersOOC = false,
    
		ActionBarButtonPosition = {
			"center",
			"center",
			"center",
			"right",
			"left",
		},
        FramePositions = {
        },
		["Anchors"] = {
			["MonkTimers_StaggerBar"] = {
				["scale"] = 0.833333313465118,
				["xOffset"] = 2.25884032249451,
				["yOffset"] = -96.3766250610352,
			},
			["XiTimersBar5"] = {
				["xOffset"] = -139.500579833984,
				["yOffset"] = -107.200149536133,
				["pointTo"] = "RIGHT",
				["pointFrom"] = "RIGHT",
			},
			["XiTimersBar1"] = {
				["xOffset"] = -5.835711635882040e-005,
				["yOffset"] = -107.199638366699,
			},
			["XiTimersBar3"] = {
				["pointTo"] = "LEFT",
				["pointFrom"] = "LEFT",
				["xOffset"] = 139.95573425293,
				["yOffset"] = -73.067367553711,
			},
			["MonkTimersHarmonyBar"] = {
				["pointFrom"] = "CENTER",
				["xOffset"] = 0,
				["scale"] = 0.75,
				["pointTo"] = "CENTER",
				["yOffset"] = -233.1025390625,
			},
			["XiTimersBar4"] = {
				["xOffset"] = 139.900344848633,
				["yOffset"] = -107.199821472168,
				["pointTo"] = "LEFT",
				["pointFrom"] = "LEFT",
			},
			["XiTimersBar2"] = {
				["xOffset"] = 4.66856909042690e-005,
				["yOffset"] = -143.467163085938,
			},
		},
		

		
		StaggerBar = true,
		StaggerHeight = 17,
		StaggerDot = true,
		StaggerDotTotal = true,
		StaggerDotPercent = true,
		ChiBar = true,
		ChiBarSize = 1,
		HideBlizzardChiBar = false,
		
		["buttons"] = {
			["MONK"] = {
				{
					nil, -- [1]
					nil, -- [2]
					{
						["id"] = 100784,
						["type"] = "spell",
					}, -- [3]
					{
						["id"] = 115181,
						["type"] = "spell",
					}, -- [4]
					{
						["id"] = 121253,
						["type"] = "spell",
					}, -- [5]
					{
						["id"] = 119582,
						["type"] = "spell",
					}, -- [6]
					{
						["id"] = 115308,
						["type"] = "spell",
					}, -- [7]
					[13] = {
						["id"] = 116841,
						["type"] = "spell",
					},
					[35] = {
						["id"] = 115399,
						["type"] = "spell",
					},
					[37] = {
						["id"] = 115176,
						["type"] = "spell",
					},
					[39] = {
						["id"] = 115203,
						["type"] = "spell",
					},
					[15] = {
						["id"] = 123986,
						["type"] = "spell",
					},
					[16] = {
						["id"] = 115546,
						["type"] = "spell",
					},
					[17] = {
						["id"] = 218164,
						["type"] = "spell",
					},
					[34] = {
						["id"] = 115315,
						["type"] = "spell",
					},
					[36] = {
						["id"] = 132578,
						["type"] = "spell",
					},
					[38] = {
						["id"] = 122783,
						["type"] = "spell",
					},
					[40] = {
						["id"] = 115078,
						["type"] = "spell",
					},
					[14] = {
						["id"] = 116705,
						["type"] = "spell",
					},
				}, -- [1]
				{
					[13] = {
						["id"] = 116841,
						["type"] = "spell",
					},
					[7] = {
						["id"] = 197945,
						["type"] = "spell",
					},
					[14] = {
						["id"] = 198898,
						["type"] = "spell",
					},
					[39] = {
						["id"] = 122278,
						["type"] = "spell",
					},
					[15] = {
						["id"] = 116849,
						["type"] = "spell",
					},
					[16] = {
						["id"] = 115310,
						["type"] = "spell",
					},
					[17] = {
						["id"] = 197908,
						["type"] = "spell",
					},
					[18] = {
						["id"] = 107428,
						["type"] = "spell",
					},
					[38] = {
						["id"] = 198664,
						["type"] = "spell",
					},
					[40] = {
						["id"] = 115078,
						["type"] = "spell",
					},
					[6] = {
						["id"] = 115450,
						["type"] = "spell",
					},
					[5] = {
						["id"] = 116680,
						["type"] = "spell",
					},
					[4] = {
						["id"] = 115151,
						["type"] = "spell",
					},
				}, -- [2]
				{
					[19] = {
						["id"] = 119381,
						["type"] = "spell",
					},
					[13] = {
						["id"] = 116841,
						["type"] = "spell",
					},
					[7] = {
						["id"] = 115098,
						["type"] = "spell",
					},
					[14] = {
						["id"] = 101545,
						["type"] = "spell",
					},
					[39] = {
						["id"] = 122470,
						["type"] = "spell",
					},
					[15] = {
						["id"] = 116705,
						["type"] = "spell",
					},
					[8] = {
						["id"] = 152175,
						["type"] = "spell",
					},
					[16] = {
						["id"] = 137639,
						["type"] = "spell",
					},
					[17] = {
						["id"] = 115288,
						["type"] = "spell",
					},
					[5] = {
						["id"] = 107428,
						["type"] = "spell",
					},
					[36] = {
						["id"] = 123904,
						["type"] = "spell",
					},
					[38] = {
						["id"] = 115080,
						["type"] = "spell",
					},
					[40] = {
						["id"] = 115078,
						["type"] = "spell",
					},
					[6] = {
						["id"] = 113656,
						["type"] = "spell",
					},
					[37] = {
						["id"] = 122278,
						["type"] = "spell",
					},
					[18] = {
						["id"] = 218164,
						["type"] = "spell",
					},
				}, -- [3]
			},
		},
}

MonkTimers.ActiveProfile = MonkTimers_Profiles.default


local function copy(object) 
    if type(object) ~= "table" then
        return object
    else
        local newtable = {}
        for k,v in pairs(object) do
            newtable[k] = copy(v)
        end
        return newtable
    end
end




function MonkTimers.CreateProfile(name)
    if not MonkTimers_Profiles[name] then
        MonkTimers.ResetProfile(name)
        return true
    else
        return false
    end
end


function MonkTimers.DeleteProfile(name)
    if name == "default" then return end
    MonkTimers_Profiles[name] = nil
    for u,p in pairs(MonkTimers_GlobalSettings.Profiles) do
        for i = 1,3 do
            for _,v in pairs({"none","party","arena","pvp","raid"}) do
                if p[i][v] == name then
                    p[i][v] = "default"
                end
            end
        end
    end
end

function MonkTimers.ResetProfile(name)
    MonkTimers_Profiles[name] = copy(MonkTimers.DefaultProfile)
end

function MonkTimers.ResetAllProfiles()
    MonkTimers_Profiles = {
        ["default"] = {}
    }
    MonkTimers.ResetProfile("default")
end

function MonkTimers.SelectActiveProfile()
    local player = UnitName("player")
    local specialization = GetSpecialization()
    if not specialization then specialization = 2 end
    local _,instance = IsInInstance()
	if not instance then instance = "party" end
    MonkTimers.ActiveProfile = MonkTimers_Profiles[MonkTimers_GlobalSettings.Profiles[player][specialization][instance]] or MonkTimers_Profiles.default
	XiTimers.SetProfile(MonkTimers.ActiveProfile)
end


function MonkTimers.ExecuteProfile()
	XiTimers.LoadProfile()
    MonkTimers.ProcessAllSettings()
end

local SettingsConverters = {
}

	
function MonkTimers.UpdateProfiles()

    if not MonkTimers_Profiles then MonkTimers_Profiles = {default={}} end
    
	if not MonkTimers_GlobalSettings.Version or MonkTimers_GlobalSettings.Version < 2.0 then
		DEFAULT_CHAT_FRAME:AddMessage("MonkTimers: Pre-2.0 or no saved settings found, loading defaults...")
        MonkTimers_GlobalSettings = {}
		MonkTimers.ResetAllProfiles()
	elseif MonkTimers_GlobalSettings.Version ~= Version then
        if not SettingsConverters[MonkTimers_GlobalSettings.Version] then
            DEFAULT_CHAT_FRAME:AddMessage("MonkTimers: Unknown settings found, loading defaults...")
            MonkTimers_GlobalSettings = {}
            MonkTimers.ResetAllProfiles()
        else
            while SettingsConverters[MonkTimers_GlobalSettings.Version] do
                SettingsConverters[MonkTimers_GlobalSettings.Version]()
            end
        end
    end


	for k,v in pairs(MonkTimers.DefaultProfile) do
        for _,profile in pairs(MonkTimers_Profiles) do
            if profile[k] == nil then
                profile[k] = copy(v)
            end
        end
	end
    
    
    for k,v in pairs(MonkTimers.DefaultGlobalSettings) do
        if MonkTimers_GlobalSettings[k] == nil then
            MonkTimers_GlobalSettings[k] = copy(v)
        end
    end
	
    
    local player = UnitName("player")
    if not MonkTimers_GlobalSettings.Profiles[player] then
        MonkTimers_GlobalSettings.Profiles[player] = {
            [1] = {none="default",pvp="default",arena="default",party="default",raid="default"},
            [2] = {none="default",pvp="default",arena="default",party="default",raid="default"},
            [3] = {none="default",pvp="default",arena="default",party="default",raid="default"},
        }
    end
	for i=1,3 do
		if not MonkTimers_GlobalSettings.Profiles[player][i].scenario then
			MonkTimers_GlobalSettings.Profiles[player][i].scenario = "default"
		end
	end
end

function MonkTimers.ResetProfilePositions(name)
    MonkTimers_Profiles[name].FramePositions = copy(MonkTimers.DefaultProfile.FramePositions)
    MonkTimers_Profiles[name].TimerPositions = copy(MonkTimers.DefaultProfile.TimerPositions)
    MonkTimers.ProcessSetting("FramePositions")
end

function MonkTimers.CopyProfile(p1,p2)
    MonkTimers_Profiles[p2] = copy(MonkTimers_Profiles[p1])
end

function MonkTimers.CopyFramePositions(p1, p2)
    MonkTimers_Profiles[p2].FramePositions = copy(MonkTimers_Profiles[p1].FramePositions)
    MonkTimers_Profiles[p2].TimerPositions = copy(MonkTimers_Profiles[p2].TimerPositions)
end


local GeneralList = {
    Lock, FlashRed, ShowTimerBars,
    HideBlizzTimers, Tooltips, TooltipsAtButtons,
    TimeFont, TimeColor, TimerBarTexture,
    TimerBarColor, ShowKeybinds, HideInVehicle,
    StopPulse, 
	Timers, TimerSize,
    TimerTimeHeight, 
    TimerOOCAlpha, TimersOnButtons, TimersClickthrough,	
	HideTimersOOC,
	StaggerBar, StaggerHeight, ChiBar,
}

function MonkTimers.CopyGeneralSettings(p1,p2)
    for k,v in pairs(GeneralList) do
        MonkTimers_Profiles[p2][v] = copy(MonkTimers_Profiles[p1][v])
    end
end

local TimerSettings = {
    Timers_Spells, Timers_Order, 
}

function MonkTimers.CopyCDSettings(p1,p2)
    for k,v in pairs(CDList) do
        MonkTimers_Profiles[p2][v] = copy(MonkTimers_Profiles[p1][v])
    end
end

