-- Copyright © 2008 - 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.
-- This code is not to be modified or distributed without written permission by the author.

local L = LibStub("AceLocale-3.0"):GetLocale("MonkTimers_GUI", true)

MonkTimers.options.args.timers = {
    type = "group",
    name = "timers",
    args = {
        --[[ h1 = {
            order = 2,
            type = "header",
            name = "",
        },
         time = {
            order = 8,
            type = "select",
            name = L["Time Style"],
            desc = L["Sets the format in which times are displayed"],
            values = {["mm:ss"] = "mm:ss", blizz = L["Blizz Style"], },
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimeStyle = val  MonkTimers.ProcessSetting("TimeStyle")
                        MonkTimers.ActiveProfile.TimeStyle = val  MonkTimers.ProcessSetting("TimeStyle")
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimeStyle end,
        },
        timepos = {
            order = 9,
            type = "select",
            name = L["Timer Bar Position"],
            desc = L["Timer Bar Position Desc"],
            values = {	["TOP"] = L["Top"], ["BOTTOM"] = L["Bottom"],},
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimerTimePos = val  MonkTimers.ProcessSetting("TimerTimePos")	
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimerTimePos end,
        }, ]]
        sizes = {
            order = 10,
            type = "header",
            name = L["Scaling"],
        },
        timerSize = {
            order = 11,
            type = "range",
            name = L["Button Size"],
            desc = L["Scales the timer buttons"],
            min = 16,
            max = 96,
            step = 1,
            bigStep = 2,
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimerSize = val  MonkTimers.ProcessSetting("TimerSize")	
						XiTimers.LoadProfile()
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimerSize end,
        },
        timerTimeHeight = {
            order = 12,
            type = "range",
            name = L["Time Size"],
            desc = L["Sets the font size of time strings"],
            min = 6,
            max = 40,
            step = 1,
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimerTimeHeight = val  MonkTimers.ProcessSetting("TimerTimeHeight")
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimerTimeHeight end,
        },
        spacing = {
            order = 13,
            type = "range",
            name = L["Spacing"] ,
            desc = L["Sets the space between timer buttons"],
            min = -2,
            max = 20,
            step = 1,
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimerSpacing = val  MonkTimers.ProcessSetting("TimerSpacing")	
						XiTimers.LoadProfile()
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimerSpacing end,
        },
        timeSpacing = {
            order = 14,
            type = "range",
            name = L["Time Spacing"],
            desc = L["Sets the space between timer buttons and timer bars"],
            min = 0,
            max = 20,
            step = 1,
            set = function(info, val)
                        MonkTimers.ActiveProfile.TimerTimeSpacing = val  MonkTimers.ProcessSetting("TimerTimeSpacing")	
                  end,
            get = function(info) return MonkTimers.ActiveProfile.TimerTimeSpacing end,
        },

                                   
    },
}

for i = 1,5 do
	MonkTimers.options.args.timers.args["hbar"..i] = {
		order = 100*i,
		type = "header",
		name = L["Bar"].." "..i
	}
	MonkTimers.options.args.timers.args["barbuttonpos"..i] = {
	    order = 100*i+1,
		type = "select",
		name = L["Move Active Buttons to"],
		desc = L["Move Active Buttons to Desc"],
		values = { ["center"] = L["Center"], ["left"] = L["Left"], ["right"] = L["Right"], ["grid"] = L["Don't Move"]},
		set = function(info, val)
					MonkTimers.ActiveProfile.ActionBarButtonPosition[i] = val
					MonkTimers.ProcessSetting("ActionBarButtonPosition")	
					XiTimers.PositionTimersOnBars(XiTimers.grid)
			  end,
		get = function(info) return MonkTimers.ActiveProfile.ActionBarButtonPosition[i] end,
	}
end

local ACD = LibStub("AceConfigDialog-3.0")
local frame = ACD:AddToBlizOptions("MonkTimers", L["Timers"], "MonkTimers", "timers")
frame:SetScript("OnEvent", function(self) InterfaceOptionsFrame:Hide() end)
frame:HookScript("OnShow", function(self) if InCombatLockdown() then InterfaceOptionsFrame:Hide() end MonkTimers.LastGUIPanel = self end)
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
