-- Copyright © 2012 Xianghar  <xian@zron.de>
-- All Rights Reserved.

if select(2,UnitClass("player")) ~= "MONK" then return end

local _, MonkTimers = ...

MonkTimers.AvailableSpells = {}
MonkTimers.AvailableTalents = {}

MonkTimers.SpellIDs = {
    TigerPalm = 100787,
    TigerPower = 125359,
    PowerGuard = 118636,
    BlackoutKick = 100784,
    Shuffle = 115307,
    ElusiveBrew = 115308,
    ElusiveBrewStacks = 128939,
    ElusiveBrewBuff = 115308,
    KegSmash = 121253,
    ExpelHarm = 115072,
    Guard = 115295,
    Provoke = 115546,
    DampenHarm = 122278,
    FortifyingBrew = 115203,
	FortifyingBrewBuff = 120954,
    GrappleWeapon = 117368,
	SpearHandStrike = 116705,
	ZenMeditation = 115176,
	ChiBrew = 115399,
	DiffuseMagic = 122783,
	Xuen = 123904,
	RushingJadeWind = 116847,
	LegSweep = 119381,
	ChargingOxWave = 119392,
	TouchOfKarma = 122470,
	LifeCocoon = 116849,
	Revival = 115310,
	EnergizingBrew = 115288,
	FistsOfFury = 113656,
	RisingSunKick = 107428,
	TigereyeBrew = 116740,
	TigereyeBrewStacks = 125195,
	FlyingSerpentKick = 101545,
	ThunderFocusTea = 116680,
	ChiWave = 115098,
	RenewingMist = 115151,
	Detox = 115450,
	VitalMists = 118674,
	SerpentsZeal = 127722,	
	PurifyingBrew = 119582,
	StaggerHeavy = 124273,
	StaggerModerate = 124274,
	StaggerLight = 124275,
	Stagger = 115069,
	ManaTea = 197908,
	ManaTeaGlyphed = 123761,
	ZenFlight = 125883,
	ZenSphere = 124081,
	ChiBurst = 123986,
	Purifier = 138237,
	Staggering = 138233,
	SpinningCraneKick = 101546,
	TouchOfDeath = 115080,
	Serenity = 152173,
	ChiExplosionBM = 157676,
	ChiExplosionWW = 152174,
	ChiExplosionMW = 157675,
	HurricaneStrike = 152175,
	BreathOfSerpent = 157535,
	IronskinBrew = 115308,
	SummonBlackOxStatue = 115315,
	RingOfPeace = 116844,
	HealingElixir = 122281,
	InvokeNiuzao = 132578,
	StormEarthAndFire = 137639,
	WhirlingDragonPunch = 152175,
	SongOfChiji = 198898,
	InvokeChiji = 198664,
	SummonJadeSerpentStatue = 115313,
	
	
    
}

local SpellIDs = MonkTimers.SpellIDs

MonkTimers.SpellTextures = {}
MonkTimers.SpellNames = {}

for k,v in pairs(MonkTimers.SpellIDs) do
    local n,_,t = GetSpellInfo(v)
    MonkTimers.SpellTextures[v] = t
    MonkTimers.SpellNames[v] = n
end


local function GetSpellTab(tab)
    local _, _, offset, numSpells = GetSpellTabInfo(tab)
    local AvailableSpells = MonkTimers.AvailableSpells
    for s = offset + 1, offset + numSpells do 
        local spelltype, spell = GetSpellBookItemInfo(s, BOOKTYPE_SPELL)
        if spelltype == "SPELL" then 
            AvailableSpells[spell] = true
        end
    end
end    


function MonkTimers.GetSpells()
    local AvailableSpells = MonkTimers.AvailableSpells
    wipe(AvailableSpells)
    for _,s in pairs(MonkTimers.SpellIDs) do
		AvailableSpells[s] = IsPlayerSpell(s)
		if AvailableSpells[s] then
			AvailableSpells[s] = GetSpellInfo(MonkTimers.SpellNames[s]) == MonkTimers.SpellNames[s]
		end
    end
    return true
end


function MonkTimers.LearnedSpell(spell,tab)
    if spell then
        MonkTimers.AvailableSpells[spell] = true
    else
        MonkTimers.GetSpells()
    end
end


function MonkTimers.ChangedTalents()
	MonkTimers.GetSpells()
    MonkTimers.SelectActiveProfile()
    MonkTimers.ExecuteProfile()
end



XiTimers.SpellData = {
	[SpellIDs.TigerPalm] = {
		buff = SpellIDs.TigerPower,		
	},
	[SpellIDs.BlackoutKick] = {
		roles = {
			[1] = {
				buff = SpellIDs.Shuffle,
			},
		},
		alt = {
			SpellIDs.ChiExplosionBM,
			SpellIDs.ChiExplosionMW,
			SpellIDs.ChiExplosionWW,
		},
	},
	[SpellIDs.Guard] = {
		buff = SpellIDs.Guard,
	},
	[SpellIDs.ChiExplosionBM] = {
		extend = SpellIDs.BlackoutKick,
		buff = SpellIDs.Shuffle,
	},
	[SpellIDs.ChiExplosionMW] = {
		extend = SpellIDs.BlackoutKick,
	},
	[SpellIDs.ChiExplosionWW] = {
		extend = SpellIDs.BlackoutKick,
	},
	[SpellIDs.FortifyingBrew] = {
		buff = SpellIDs.FortifyingBrewBuff,
	},
	[SpellIDs.IronskinBrew] = {
		buff = SpellIDs.IronskinBrew,
	},
	[SpellIDs.ZenMeditation] = {
		buff = SpellIDs.ZenMeditation,
	},
	[SpellIDs.ChiWave] = {
		alt = {
			SpellIDs.ChiBurst,
		}
	},
	[SpellIDs.ChiBurst] = {
		alt = {
			SpellIDs.ChiWave,
		},
	},
	[SpellIDs.RingOfPeace] = {
		alt = {
			SpellIDs.SummonBlackOxStatue,
			SpellIDs.LegSweep,
			SpellIDs.SongOfChiji,
		},
	},
	[SpellIDs.SummonBlackOxStatue] = {
		alt = {
			SpellIDs.RingOfPeace,
			SpellIDs.LegSweep,
		}
	},
	[SpellIDs.LegSweep] = {
		alt = {
			SpellIDs.SongOfChiji,
			SpellIDs.RingOfPeace,
			SpellIDs.SummonBlackOxStatue,
		},
	},
	[SpellIDs.SongOfChiji] = {
		alt = {
			SpellIDs.RingOfPeace,
			SpellIDs.LegSweep,
		},
	},
	[SpellIDs.DampenHarm] = {
		buff = SpellIDs.DampenHarm,
		alt = {
			SpellIDs.DiffuseMagic,
			SpellIDs.HealingElixir,
		},
	},
	[SpellIDs.DiffuseMagic] = {
		buff = SpellIDs.DiffuseMagic,
		alt = {
			SpellIDs.DampenHarm,
			SpellIDs.HealingElixir,
		},
	},
	[SpellIDs.HealingElixir] = {
		alt = {
			SpellIDs.DiffuseMagic,
			SpellIDs.DampenHarm,
		},
	},
	[SpellIDs.RushingJadeWind] = {
		alt = {
			SpellIDs.InvokeNiuzao,
			SpellIDs.Xuen,
		},
	},
	[SpellIDs.InvokeNiuzao] = {
		alt = {
			SpellIDs.RushingJadeWind
		},
	},
	[SpellIDs.StormEarthAndFire] = {
		buff = SpellIDs.StormEarthAndFire,
		upgrade = SpellIDs.Serenity,
	},
	[SpellIDs.Serenity] = {
		buff = SpellIDs.Serenity,
		alt = {
			SpellIDs.StormEarthAndFire,
		},
	},
	[SpellIDs.Xuen] = {
		alt = {
			SpellIDs.RushingJadeWind,
		},
	},
	[SpellIDs.InvokeChiji] = {
		alt = {
			SpellIDs.SummonJadeSerpentStatue,
		},
	},
	[SpellIDs.SummonBlackOxStatue] = {
		alt = {
			SpellIDs.InvokeChiji,
		},
	},
	[SpellIDs.ManaTea] = {
		buff = SpellIDs.Manatea,
	},
	
}
